org.springframework.messaging.converter

## Class ProtobufJsonFormatMessageConverter

- java.lang.Object
- - org.springframework.messaging.converter.AbstractMessageConverter
  - - org.springframework.messaging.converter.ProtobufMessageConverter
    - - org.springframework.messaging.converter.ProtobufJsonFormatMessageConverter

All Implemented Interfaces:
  MessageConverter, SmartMessageConverter

    public class ProtobufJsonFormatMessageConverter
    extends ProtobufMessageConverter

Subclass of `ProtobufMessageConverter` for use with the official `"com.google.protobuf:protobuf-java-util"` library for JSON support.

Most importantly, this class allows for custom JSON parser and printer configurations through the `JsonFormat` utility. If no special parser or printer configuration is given, default variants will be used instead.

Requires Protobuf 3.x and `"com.google.protobuf:protobuf-java-util"` 3.x, with 3.3 or higher recommended.

Since:
  5.2.2
Author:
  Rossen Stoyanchev

### Field Summary

### Fields inherited from class org.springframework.messaging.converter.ProtobufMessageConverter

`DEFAULT_CHARSET, PROTOBUF`

### Fields inherited from class org.springframework.messaging.converter.AbstractMessageConverter

`logger`

### Constructor Summary

Constructors
Constructor and Description
`ProtobufJsonFormatMessageConverter(com.google.protobuf.ExtensionRegistry extensionRegistry)` Constructor with default instances of `JsonFormat.Parser`, `JsonFormat.Printer`, and `ExtensionRegistry`.
`ProtobufJsonFormatMessageConverter(com.google.protobuf.util.JsonFormat.Parser parser, com.google.protobuf.util.JsonFormat.Printer printer)` Constructor with given instances of `JsonFormat.Parser`, `JsonFormat.Printer`, and a default instance of `ExtensionRegistry`.
`ProtobufJsonFormatMessageConverter(com.google.protobuf.util.JsonFormat.Parser parser, com.google.protobuf.util.JsonFormat.Printer printer, com.google.protobuf.ExtensionRegistry extensionRegistry)` Constructor with given instances of `JsonFormat.Parser`, `JsonFormat.Printer`, and `ExtensionRegistry`.

### Method Summary

### Methods inherited from class org.springframework.messaging.converter.ProtobufMessageConverter

`canConvertTo, convertFromInternal, convertToInternal, supports`

### Methods inherited from class org.springframework.messaging.converter.AbstractMessageConverter

`addSupportedMimeTypes, canConvertFrom, fromMessage, fromMessage, getContentTypeResolver, getDefaultContentType, getMimeType, getSerializedPayloadClass, getSupportedMimeTypes, isStrictContentTypeMatch, setContentTypeResolver, setSerializedPayloadClass, setStrictContentTypeMatch, supportsMimeType, toMessage, toMessage`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ProtobufJsonFormatMessageConverter

    public ProtobufJsonFormatMessageConverter(@Nullable
                                              com.google.protobuf.ExtensionRegistry extensionRegistry)

Constructor with default instances of `JsonFormat.Parser`, `JsonFormat.Printer`, and `ExtensionRegistry`.

#### ProtobufJsonFormatMessageConverter

    public ProtobufJsonFormatMessageConverter(@Nullable
                                              com.google.protobuf.util.JsonFormat.Parser parser,
                                              @Nullable
                                              com.google.protobuf.util.JsonFormat.Printer printer)

Constructor with given instances of `JsonFormat.Parser`, `JsonFormat.Printer`, and a default instance of `ExtensionRegistry`.

#### ProtobufJsonFormatMessageConverter

    public ProtobufJsonFormatMessageConverter(@Nullable
                                              com.google.protobuf.util.JsonFormat.Parser parser,
                                              @Nullable
                                              com.google.protobuf.util.JsonFormat.Printer printer,
                                              @Nullable
                                              com.google.protobuf.ExtensionRegistry extensionRegistry)

Constructor with given instances of `JsonFormat.Parser`, `JsonFormat.Printer`, and `ExtensionRegistry`.